import codecs
import os

from setuptools import find_packages, setup

###############################################################################

NAME = "pyalmostnothing"
PACKAGES = find_packages(where="src")
KEYWORDS = []
PROJECT_URLS = {
    "Documentation": "https://www.attrs.org/",
    "Bug Tracker": "https://github.com/python-attrs/attrs/issues",
    "Source Code": "https://github.com/python-attrs/attrs",
}
AUTHOR = "Nazime LAKEHAL"
AUTHOR_EMAIL = "nazime.lkh@gmail.com"
CLASSIFIERS = [
    "Development Status :: 3 - Alpha",
    "Natural Language :: English",
    "License :: OSI Approved :: MIT License",
    "Operating System :: OS Independent",
    "Programming Language :: Python",
    "Programming Language :: Python :: 3.6",
    "Programming Language :: Python :: 3.7",
    "Programming Language :: Python :: 3.8",
]
INSTALL_REQUIRES = []
EXTRAS_REQUIRE = {
    "docs": ["sphinx"],
    "tests": [
        "coverage",
        "hypothesis",
        "pytest>=4.3.0",  # 4.3.0 dropped last use of `convert`
    ],
}
EXTRAS_REQUIRE["dev"] = (
    EXTRAS_REQUIRE["tests"] + EXTRAS_REQUIRE["docs"] + ["pre-commit"]
)

EXTRAS_REQUIRE["travis"] = EXTRAS_REQUIRE["dev"] + ["tox", "codecov"]

###############################################################################

HERE = os.path.abspath(os.path.dirname(__file__))


def read(*parts):
    """
    Build an absolute path from *parts* and and return the contents of the
    resulting file.  Assume UTF-8 encoding.
    """
    with codecs.open(os.path.join(HERE, *parts), "rb", "utf-8") as f:
        return f.read()


VERSION = "0.1.2"
URL = "https://github.com/nazime/project"
LONG = read("README.rst")
LONG_DESCRIPTION_CONTENT_TYPE = "text/x-rst"
DESCRIPTION = "Lol"
LICENSE = "MIT"
MAINTAINER = AUTHOR
MAINTAINER_EMAIL = AUTHOR_EMAIL
PACKAGE_DIR = {"": "src"}
PYTHON_REQUIRES = ">=3.6"
ZIP_SAFE = False
ENTRY_POINTS = {}

if __name__ == "__main__":
    setup(
        name=NAME,
        description=DESCRIPTION,
        license=LICENSE,
        url=URL,
        project_urls=PROJECT_URLS,
        version=VERSION,
        author=AUTHOR,
        author_email=AUTHOR_EMAIL,
        maintainer=MAINTAINER,
        maintainer_email=MAINTAINER_EMAIL,
        keywords=KEYWORDS,
        long_description=LONG,
        long_description_content_type=LONG_DESCRIPTION_CONTENT_TYPE,
        packages=PACKAGES,
        package_dir=PACKAGE_DIR,
        python_requires=PYTHON_REQUIRES,
        zip_safe=ZIP_SAFE,
        classifiers=CLASSIFIERS,
        install_requires=INSTALL_REQUIRES,
        extras_require=EXTRAS_REQUIRE,
        include_package_data=True,
        entry_points=ENTRY_POINTS,
    )
