import argparse
import sys

from pycalculate import add, inc, mult


# must have main function with no arguments for entry_points (setuptools)
def main():
    parser = argparse.ArgumentParser(description="This is a simple script")
    parser.add_argument("func", help="function")
    parser.add_argument("args", help="arguments", type=int, nargs="+")

    args = parser.parse_args()

    if args.func == "add":
        assert len(args.args) == 2
        print(add(args.args[0], args.args[1]))
    elif args.func == "mult":
        assert len(args.args) == 2
        print(mult(args.args[0], args.args[1]))
    elif args.func == "inc":
        assert len(args.args) == 1
        print(inc(args.args[0]))
    else:
        sys.exit(f"Function '{args.func}' don't exist")


if __name__ == "__main__":
    main()
